import React, { useState } from 'react';
import PropTypes from 'prop-types';
import CollapsibleBasic from '@s-ui/react-collapsible-basic';

function CollapsibleAccordion(_ref) {
  var _ref$preserveState = _ref.preserveState,
      preserveState = _ref$preserveState === void 0 ? false : _ref$preserveState,
      _ref$onItemChange = _ref.onItemChange,
      onItemChange = _ref$onItemChange === void 0 ? function (collapsed, id) {} : _ref$onItemChange,
      items = _ref.items,
      icon = _ref.icon;

  var _useState = useState(null),
      openIndex = _useState[0],
      setOpenIndex = _useState[1];

  var handleClick = function handleClick(id) {
    return function (collapsed) {
      return !preserveState && collapseItems(collapsed, id);
    };
  };

  var collapseItems = function collapseItems(collapsed, id) {
    var newOpenIndex = id === openIndex ? null : id;
    setOpenIndex(newOpenIndex);
    onItemChange(collapsed, id);
  };

  return React.createElement("div", null, items.map(function (item, index) {
    return React.createElement(CollapsibleBasic, Object.assign({
      key: index
    }, item, {
      collapsed: openIndex !== index,
      handleClick: handleClick(index),
      icon: icon
    }), item.content);
  }));
}

CollapsibleAccordion.displayName = 'CollapsibleAccordion';
export default CollapsibleAccordion;